#include "processUtils.h"
#include "pim/ClientSettings.h"
#include "base/startcmd.h"
#include <xstring>
using namespace std;


int startProgram(const wchar_t *app, const wchar_t *cmdline)
{   
    PROCESS_INFORMATION procinfo;
     
    wchar_t *path = NULL;
    path = toWideChar(getRegConfig()->getPath().c_str());
    wstring cmd;
    
    if (path) {
        cmd += path;
        delete [] path;
    }
    cmd += TEXT("\\"); cmd += app;

    LOG.debug("Running: %ls %ls\n", cmd.c_str(), cmdline);
    if( CreateProcess( cmd.c_str(), cmdline,
                        NULL, NULL, FALSE, 0,
                        NULL, NULL, NULL, &procinfo ) ) {
        return procinfo.dwProcessId;
    }
    else {
        //-- maybe the Registry entry is missing, trying startcmd()
        int pid = startcmd(app, cmdline);
        return pid;
    }
}