/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef __WORKER_H
#define __WORKER_H
/** @cond WMPLUGIN_NOTLISTENER */
/** @ingroup NotificationListenerDll */
/** @{ */
#include <windows.h>
#include <winsock2.h>

#include "s4jproxy.h"
#include "CTPMessage.h"

DWORD startWorker(SOCKET sock);
DWORD stopWorker();

const char *processPacket(const char *buf, int len);
const char *getMsg();
int getLen();

// Worker threads for stp/ctp
DWORD WINAPI stpWorker       (LPVOID lpv);
DWORD WINAPI ctpWorker       (LPVOID lpv);
DWORD WINAPI receiveWorker   (LPVOID lpv);
DWORD WINAPI heartbeatWorker (LPVOID lpv);
DWORD WINAPI byeWorker       (LPVOID lpv);
DWORD WINAPI cmdTimeoutWorker(LPVOID lpv);

void setServerNotified(bool val);
bool saveNonceParam(CTPMessage* authStatusMsg);
int printErrorStatus(CTPMessage* statusMsg);
int startSyncFromSAN(SyncNotification* sn);
int extractMsgLength(const char* package, int packageLen);
void hexDump(char *buf, int len);

DWORD WINAPI checkInternetConnectionWorker(LPVOID lpv);
HANDLE starCheckInternetConnectionWorker();
bool stopCheckInternetConnectionWorker(int exitCode) ;

/** @} */
/** @endcond */
#endif

